#ifndef SCENE_H_
#define SCENE_H_

#include "vector.h"
#include "sprite.h"
#include "object.h"

typedef struct Scene Scene;
typedef void (*Scene_func)(Scene*);
typedef bool (*Scene_func_add_object)(Scene*, Object*);
typedef bool (*Scene_func_add_sprite)(Scene*, Sprite*);
struct Scene {
    char* name;
    Vector* objects;
    Vector* sprites;

    Scene_func_add_object add_object;
    Scene_func_add_sprite add_sprite;
    Scene_func update;
    Scene_func draw;
    Scene_func load;
};

void free_Scene(Scene* self);
Scene* new_Scene(const char* name);
Scene* current_Scene();

#endif
